// ------------------------------------
// buildCanvas
// ------------------------------------
function buildCanvas(ofJSObj)
{

}



// ------------------------------------
// glCanvas instance
// ------------------------------------
glCanvas = 
{
	id : "",
	w 	: 800,
	h	: 600,
	offsetLeft:0,
	offsetTop:0,
	
	getContext : function(what)
	{
		switch(what)
		{
			case "2d":
				var context2d = 
					{
						// Custom
						arcResolution : 5, // used for drawing ellipses with triangles
					
						// Members
						globalAlpha				 : 1.0,
						globalCompositeOperation : "",
						strokeStyleVal			 : {r:0,g:0,b:0,a:1},
						fillStyleVal			 : {r:0,g:0,b:0,a:1},
						lineWidth				 : 1,
						lineCap					 : "butt",

						// Methods
						drawImage : function(obj,x,y)
						{},

						// Transformations
						moveTo : function(x,y)
						{
							gl.Translate(x,y,0);	
						},
						translate : function(x,y)
						{
							gl.Translate(x,y,0);	
						},
						scale : function(x,y)
						{
							gl.Scale(x,y,1);	
						},
						rotate : function(x,y)
						{
							of.RotateY(x);	
							of.RotateX(x);	
						},
						
						// State
						pushMatrix : function()
						{
							of.PushMatrix();	
						},
						popMatrix : function()
						{
							of.PopMatrix();	
						},
						fill : function()
						{
							if (this.fillStyleVal)
								of.SetColor(this.fillStyleVal.r,this.fillStyleVal.g,this.fillStyleVal.b);
						},
						stroke : function()
						{
							if (this.strokeStyleVal)
								of.SetColor(this.strokeStyleVal.r,this.strokeStyleVal.g,this.strokeStyleVal.b);
						},
						save : function()
						{},
						restore : function()
						{},
						lineTo : function(x,y)
						{
							of.Line(0,0,x,y);
						},

						// Drawing
						beginPath : function()
						{},
						closePath : function()
						{},
						quadraticCurveTo : function(x1,y1,x2,y2)
						{},
						bezierCurveTo : function(x1,y1,x2,y2,x3,y3)
						{},
						fillRect : function(x,y,w,h)
						{
							of.Rect(x,y,w,h);
						},
						rect : function(x,y,w,h)
						{
							of.Rect(x,y,w,h);
						},
						arc : function(x,y,radius,startAngle,endAngle)
						{
						}
					};
					
				context2d.__defineSetter__("strokeStyle",	
											function(val)
											{
												if (val)
												{
													var c = val.slice(5,-1).split(",");
													this.strokeStyleVal.r = parseFloat(c[0])/255;
													this.strokeStyleVal.g = parseFloat(c[1])/255;
													this.strokeStyleVal.b = parseFloat(c[2])/255;
													this.strokeStyleVal.a = parseFloat(c[3]);
													this.stroke();
												}
											});
				context2d.__defineSetter__("fillStyle",		
											function(val)
											{
												if (val)
												{
													var c = val.slice(5,-1).split(",");
													this.fillStyleVal.r = parseFloat(c[0])/255;
													this.fillStyleVal.g = parseFloat(c[1])/255;
													this.fillStyleVal.b = parseFloat(c[2])/255;
													this.fillStyleVal.a = parseFloat(c[3]);
													this.fill();
												}
											});


				return context2d;
			break;		
		}
	}
	
};

glCanvas.addEventListener = function(type,fn,is)
{
	eventDispatcher.addEventListeners( type, fn );
}

glCanvas.__defineSetter__("width",	function(val){this.w = val;sizeWindow(this.w, this.h);});
glCanvas.__defineGetter__("width",	function(){return this.w;});

glCanvas.__defineSetter__("height", function(val){this.h = val;sizeWindow(this.w, this.h);});
glCanvas.__defineGetter__("height",	function(){return this.h;});
