// ------------------------------------
include("libraries/eventDispatcher.js")
include("libraries/glCanvas.js")
include("libraries/setInterval.js")
include("libraries/file.js")

// ------------------------------------
eventDispatcher = new EventDispatcher();
document		= {}; // Dirty hack !
document.addEventListener = function(type,fn,is)
{
	eventDispatcher.addEventListeners( type, fn );
}

// ------------------------------------
// sizeWindow
// ------------------------------------
function sizeWindow(w,h)
{
	of.SetWindowShape(w,h);
}

// ------------------------------------
// update
// ------------------------------------
function run(dt)
{
	setIntervalManager.run(dt);
}

// ------------------------------------
// mouseMove
// ------------------------------------
function mousemove(x,y)
{
	eventDispatcher.dispatchEvent( {type:"mousemove", clientX:x, clientY:y} );
}

// ------------------------------------
// mousedown
// ------------------------------------
function mousedown()
{
	eventDispatcher.dispatchEvent( {type:"mousedown"} );
}

// ------------------------------------
// mouseup
// ------------------------------------
function mouseup()
{
	eventDispatcher.dispatchEvent( {type:"mouseup"} );
}

// ------------------------------------
// keydown
// ------------------------------------
function keydown(k)
{
	eventDispatcher.dispatchEvent( {type:"keydown", keyCode:k} );
}

// ------------------------------------
// keyup
// ------------------------------------
function keyup(k)
{
	eventDispatcher.dispatchEvent( {type:"keyup", keyCode:k} );
}
