// boundingbox.js

//--------------------------------------------------------------
function setup()
{
	of.SetWindowTitle("LiveCoding / font/ boundingbox.js");

	this.myFont = new ofxJSTrueTypeFont();
	this.myFont.loadFont(this.path+"Helvetica.ttf",40);

	of.SetWindowShape(800, 600);
	of.SetBackgroundAuto(false);
	of.SetVerticalSync(true);
	of.EnableSmoothing();


    this.char = this.myFont.getCharacterAsPoints(65+22);
    println("contours="+this.char.contours.length);
}

//--------------------------------------------------------------
function update()
{
}

//--------------------------------------------------------------
function draw()
{
	of.Background(0,0,0);
    of.SetColor(255,255,255);

    of.Translate(500,150,0);
    of.RotateY(this.mouseX/of.GetWidth()*360);
    gl.Scale(3,3,3);
    for each(contour in this.char.contours){
        var pt  = null;
        var ptNext  = null;
        var nbPts   = contour.pts.length;

        gl.Begin(GL_LINE_STRIP);
        for (i=0;i<=nbPts;i++){
                pt = contour.pts[i%nbPts];
                gl.Vertex3(pt.x,pt.y,of.Random(-3,3));
            }
        gl.End();
        }

}

//--------------------------------------------------------------
function mouseMoved(x,y)
{
}

