// pixels.js


//--------------------------------------------------------------
function setup()
{
	of.SetWindowTitle("LiveCoding / pixels.js");

	this.myImage = new ofxJSImage();
	this.myImage.loadImage(this.path+"bike_icon.png");
	this.myImage2 = new ofxJSImage();
	this.myImage2.loadImage(this.path+"tdf_1972_poster.jpg");
    this.myImage2.resize(this.myImage2.width,this.myImage2.height);
//    this.myImage.setImageType(0);

    this.size   = 30;
    this.pixels = this.myImage.getPixels();

	of.SetWindowShape(myImage.width*this.size, myImage.height*this.size);
	of.SetBackgroundAuto(false);
	of.SetVerticalSync(true);
}

//--------------------------------------------------------------
function draw()
{
    of.Background(0,0,0);
    this.myImage2.draw(0,0);
    of.Translate(this.size/2,this.size/2,0);
    for (i=0;i<this.myImage.width;i++)
        for (j=0;j<this.myImage.height;j++){
            value = this.pixels[i+j*this.myImage.width];
            pct = 1-(value/0xffffff);
            of.SetColor(255,255,255,250);
            of.Circle(i*this.size,j*this.size,pct*this.size/2);
    
    }

}


