function EventDispatcher()
{
	// Cool !!
	this.__noSuchMethod__ = function(arg){ print('- [EventDispatcher (JS)] unable to call "'+arg+'" function.\n') }

	// Dispatch group
	this.m_dispatchGroupList = new Array();	
	
	this.addEventListeners = function(eType, obj, cb)
	{

		if (this.m_dispatchGroupList[eType] == undefined)
			this.m_dispatchGroupList[eType] = new Array();

		if (arguments.length==3)
			this.m_dispatchGroupList[eType].push( {obj:obj, callback:cb} );
		if (arguments.length==2)
		{
			this.m_dispatchGroupList[eType].push( {callback:obj} );
		}
	}
	
	// removeEventListener
	this.removeEventListener = function(eType,obj)
	{
		// get the dispatch group
		var dispatchGroup = this.m_dispatchGroupList[eType];	
		if (dispatchGroup)
		{
			var indexRemove = -1;
			for (var i=0;i<dispatchGroup.length;i++)
				if (dispatchGroup[i].obj == obj)
				{
					indexRemove = i;
					break;
				}
			indexRemove > -1 && dispatchGroup.splice(indexRemove,1);
		}
	}
	
	// dispatchEvent
	this.dispatchEvent = function(e)
	{
		if (e.type)
		{
			// get the dispatch group
			var dispatchGroup = this.m_dispatchGroupList[e.type];	
			if (dispatchGroup)
			{
				for (i=0;i<dispatchGroup.length;i++)
				{
					listener = dispatchGroup[i];
					listener.callback.call(listener.obj ? null : listener.obj, e);
				}
			}
		}
	}
};
