// ------------------------------------
setIntervalManager = 
{
	fArray : new Array(),
	register : function(f,delta,obj)
	{
		if (this.fArray.indexOf(f)<0)
		{
			this.fArray.push({t:delta,callback:f, dt:delta, obj:obj});		

		}
	},
	run : function(dt)
	{
		for each ( var f in this.fArray )
		{
			f.t += dt;
			if (f.t>=f.dt)
			{
				f.t = 0;
				f.callback.call(f.obj);
			}
		}
	}
}
// ------------------------------------
function setInterval(f,delta,obj)
{
	setIntervalManager.register(f,delta,obj);
}
