function Particle()
{
    this.p = new Vector3();
    this.pT = new Vector3();
    this.v = new Vector3();
    this.a = new Vector3();
    this.d = new Vector3();
    this.contour=null;
    this.indexPoint=0;
    // --------------------------------
    this.draw = function(){
        of.Rect(this.p.x,this.p.y,5,5);
    }
    // --------------------------------
    this.setContour = function(contour){
        this.contour = contour;
    }
    // --------------------------------
    this.update = function(){
        this.d.sub(this.pT,this.p);
        this.d.multiply(0.02);
        this.p.addSelf(this.d);

        if (this.p.distanceToSquared(this.pT) < 1){
            this.setTargetNextPoint();
        }
    }
    // --------------------------------
    this.setTargetNextPoint = function()
    {
        if (this.contour){
            var pt = this.contour.pts[this.indexPoint];
            this.setTarget(pt.x,pt.y,0);
            this.indexPoint = (this.indexPoint+1)%this.contour.pts.length;
        }
    }
    // --------------------------------
    this.set = function(x,y,z){
        this.p.init(x,y,z);
    }
    // --------------------------------
    this.setTarget = function(x,y,z){
        this.pT.init(x,y,z);
    }
}
