// soundPlayer.js

//--------------------------------------------------------------
function setupOnce()
{
	this.beats = new ofxJSSoundPlayer();
    this.beats.loadSound(this.path+"sounds/beat.wav",false);
    this.beats.setVolume(1);
    this.spectrum = null;

	of.SetWindowTitle("LiveCoding / soundPlayer.js");
	of.SetWindowShape(512, 400);
}

//--------------------------------------------------------------
function setup()
{
}

//--------------------------------------------------------------
function update()
{
}

//--------------------------------------------------------------
function draw()
{
    this.spectrum = of.SoundGetSpectrum(512);
    of.Background(0,0,0);
    of.Translate(0,of.GetHeight()/2,0);
    of.SetColor(255,255,255);
    if (this.spectrum){
        for (i=0;i<512;i++)
            of.Line(i,0,i,-1000*this.spectrum[i]);
    }
}

//--------------------------------------------------------------
function exit()
{
}

//--------------------------------------------------------------
function mousePressed(btn)
{
    this.beats.play();

}